unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqlite3conn, sqldb, db, Forms, Graphics, DbCtrls, ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    DBImage1: TDBImage;
    DBLookupComboBox1: TDBLookupComboBox;
    Image1: TImage;
    SQLite3Connection1: TSQLite3Connection;
    SQLQuery1: TSQLQuery;
    SQLQuery2: TSQLQuery;
    SQLQuery3: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure FormCreate(Sender: TObject);
    procedure SQLQuery1AfterScroll(DataSet: TDataSet);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);

  procedure CreateTable;                                    //Erstellt zuerst die Tabelle
  begin
    SQLQuery3.SQL.Text:=
      'CREATE TABLE IF NOT EXISTS picts ('+
      'id INTEGER PRIMARY KEY AUTOINCREMENT, '+
      'pic BLOB'+
      ');';
    SQLQuery3.ExecSQL;
    SQLTransaction1.Commit;
  end;
  function PictureCount: Integer;                           //Gibt die Zahl der Einträge in Picts zurück
  begin
    SQLQuery3.SQL.Text:='SELECT count(id) FROM picts;';
    SQLQuery3.Open;
    Result:=SQLQuery3.Fields[0].AsInteger;
    SQLQuery3.Close;
  end;
  procedure FillTable;                                      //Füllt die Tabelle mit Testinhalt
  var
    aPicture: TPicture;
    Info: TSearchRec;
  begin
    try
      aPicture:=TPicture.Create;

      if FindFirst ('*.jpg', faAnyFile, Info) = 0 then begin
        repeat
          SQLQuery3.SQL.Text:='INSERT INTO picts (pic) VALUES (:apic);';
          SQLQuery3.ParamByName('apic').LoadFromFile(Info.Name, ftBlob);
          SQLQuery3.ExecSQL;
        until FindNext(Info) <> 0;
      end;
      FindClose(Info);

      SQLTransaction1.Commit;
    finally
      aPicture.Free;
    end;
  end;

begin
  try
    SQLite3Connection1.Connected:=True;

    CreateTable;
    if PictureCount = 0 then FillTable;

    SQLQuery1.SQL.Text:='SELECT id FROM picts;';
    SQLQuery1.Open;

    DBLookupComboBox1.KeyField:='id';
  except
  end;
end;

procedure TForm1.SQLQuery1AfterScroll(DataSet: TDataSet);
var
  aStream: TStream;
begin
  SQLQuery2.Close;
  SQLQuery2.SQL.Text:='SELECT pic FROM picts WHERE id = :aid;';
  SQLQuery2.ParamByName('aid').AsInteger:=SQLQuery1.FieldByName('id').AsInteger;
  SQLQuery2.Open;
  DBImage1.DataField:='pic';  //In Lazarus-Trunc funktioniert dies
  try                         //Ab hier ist der Workaround
    aStream:=TStream.Create;
    aStream:=SQLQuery2.CreateBlobStream(SQLQuery2.FieldByName('pic'), bmRead);
    aStream.Position:=0;
    Image1.Picture.LoadFromStream(aStream);
  finally
    aStream.Free;
  end;
end;

end.

